/*   "        / "
      SummaYear1  PaymentSchedule  ,       ,     . 
      Summa        ... ,  ,       . 
     Summa  PaymentSchedule   (ProgIndex=317, 318) .
*/

SET TERM !! ;

CREATE OR ALTER TRIGGER TR_PAYMENTSCHEDULE_BI_1 FOR PAYMENTSCHEDULE
BEFORE INSERT POSITION 1
as
begin
    /*  1.0*/
    new.Quarter1 = new.Month01 + new.Month02 + new.Month03;
    new.Quarter2 = new.Month04 + new.Month05 + new.Month06;
    new.Quarter3 = new.Month07 + new.Month08 + new.Month09;
    new.Quarter4 = new.Month10 + new.Month11 + new.Month12;
    if (new.ProgIndex not in (317,318)) then
      new.Summa = new.Quarter1 + new.Quarter2 + new.Quarter3 + new.Quarter4;
end
!!

CREATE OR ALTER TRIGGER TR_PAYMENTSCHEDULE_BU_1 FOR PAYMENTSCHEDULE 
BEFORE UPDATE POSITION 1
as
begin
    /*  1.0*/
    new.Quarter1 = new.Month01 + new.Month02 + new.Month03;
    new.Quarter2 = new.Month04 + new.Month05 + new.Month06;
    new.Quarter3 = new.Month07 + new.Month08 + new.Month09;
    new.Quarter4 = new.Month10 + new.Month11 + new.Month12;
    if (new.ProgIndex not in (317,318)) then
      new.Summa = new.Quarter1 + new.Quarter2 + new.Quarter3 + new.Quarter4;
end
!!

commit work!!

SET TERM ; !!

