-- #########################################################
-- #########################################################
-- Alter_TR_PAYMENTSCHEDULE_BI_1.sql
-- #########################################################
-- #########################################################

/*   "        / "
      SummaYear1  PaymentSchedule  ,       ,     . 
      Summa        ... ,  ,       . 
     Summa  PaymentSchedule   (ProgIndex=317, 318) .
*/
-- CREATE TRIGGER TR_PAYMENTSCHEDULE_BI_1
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_II
  INSTEAD OF INSERT
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$REGPROJECTRESULT PAYMENTSCHEDULE.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$PAYTARGETFUNDS PAYMENTSCHEDULE.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION PAYMENTSCHEDULE.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PreviousInner$ NUMBER(10);
  AdjDocNum$ NUMBER(10);
  Tmp$ NUMBER(10);
  InnerNumber_parent$ NUMBER(10);
  InnerNumber_child$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_PAYMENTSCHEDULE_BI)
-- Version 14.00.00.4
-- - - - - - - - - - - - -

  /*   13.10.01*/
  IF (new$id IS NULL) THEN
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$Accepted IS NULL) THEN
    new$Accepted := 1;
  END IF;
  IF (new$PromiseType IS NULL) THEN
    new$PromiseType := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN
    new$KFSR := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN
    new$KVSR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN
    new$KCSR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN
    new$KVR := 0;
  END IF;
  IF (new$SubKESR IS NULL) THEN
    new$SubKESR := 0;
  END IF;
  IF (new$AssignmentKind IS NULL) THEN
    new$AssignmentKind := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN
    new$DirectionCls := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$Region IS NULL) THEN
    new$Region := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN
    new$MeansType := 0;
  END IF;
  IF (new$FinSource IS NULL) THEN
    new$FinSource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN
    new$FinType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN
    new$Fact := 0;
  END IF;
  IF (new$BuhOperationCLS IS NULL) THEN
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  IF (new$Month01 IS NULL) THEN
    new$Month01 := 0;
  END IF;
  IF (new$Month02 IS NULL) THEN
    new$Month02 := 0;
  END IF;
  IF (new$Month03 IS NULL) THEN
    new$Month03 := 0;
  END IF;
  IF (new$Month04 IS NULL) THEN
    new$Month04 := 0;
  END IF;
  IF (new$Month05 IS NULL) THEN
    new$Month05 := 0;
  END IF;
  IF (new$Month06 IS NULL) THEN
    new$Month06 := 0;
  END IF;
  IF (new$Month07 IS NULL) THEN
    new$Month07 := 0;
  END IF;
  IF (new$Month08 IS NULL) THEN
    new$Month08 := 0;
  END IF;
  IF (new$Month09 IS NULL) THEN
    new$Month09 := 0;
  END IF;
  IF (new$Month10 IS NULL) THEN
    new$Month10 := 0;
  END IF;
  IF (new$Month11 IS NULL) THEN
    new$Month11 := 0;
  END IF;
  IF (new$Month12 IS NULL) THEN
    new$Month12 := 0;
  END IF;
  IF (new$Quarter1 IS NULL) THEN
    new$Quarter1 := 0;
  END IF;
  IF (new$Quarter2 IS NULL) THEN
    new$Quarter2 := 0;
  END IF;
  IF (new$Quarter3 IS NULL) THEN
    new$Quarter3 := 0;
  END IF;
  IF (new$Quarter4 IS NULL) THEN
    new$Quarter4 := 0;
  END IF;
  IF (new$Summa IS NULL) THEN
    new$Summa := 0;
  END IF;
  IF (new$Month01Delta IS NULL) THEN
    new$Month01Delta := 0;
  END IF;
  IF (new$Month02Delta IS NULL) THEN
    new$Month02Delta := 0;
  END IF;
  IF (new$Month03Delta IS NULL) THEN
    new$Month03Delta := 0;
  END IF;
  IF (new$Month04Delta IS NULL) THEN
    new$Month04Delta := 0;
  END IF;
  IF (new$Month05Delta IS NULL) THEN
    new$Month05Delta := 0;
  END IF;
  IF (new$Month06Delta IS NULL) THEN
    new$Month06Delta := 0;
  END IF;
  IF (new$Month07Delta IS NULL) THEN
    new$Month07Delta := 0;
  END IF;
  IF (new$Month08Delta IS NULL) THEN
    new$Month08Delta := 0;
  END IF;
  IF (new$Month09Delta IS NULL) THEN
    new$Month09Delta := 0;
  END IF;
  IF (new$Month10Delta IS NULL) THEN
    new$Month10Delta := 0;
  END IF;
  IF (new$Month11Delta IS NULL) THEN
    new$Month11Delta := 0;
  END IF;
  IF (new$Month12Delta IS NULL) THEN
    new$Month12Delta := 0;
  END IF;
  IF (new$Quarter1Delta IS NULL) THEN
    new$Quarter1Delta := 0;
  END IF;
  IF (new$Quarter2Delta IS NULL) THEN
    new$Quarter2Delta := 0;
  END IF;
  IF (new$Quarter3Delta IS NULL) THEN
    new$Quarter3Delta := 0;
  END IF;
  IF (new$Quarter4Delta IS NULL) THEN
    new$Quarter4Delta := 0;
  END IF;
  IF (new$SummaDelta IS NULL) THEN
    new$SummaDelta := 0;
  END IF;
  IF (new$SummaPreviousYear IS NULL) THEN
    new$SummaPreviousYear := 0;
  END IF;
  IF (new$SummaFinPreviousYear IS NULL) THEN
    new$SummaFinPreviousYear := 0;
  END IF;
  IF (new$SummaYear2 IS NULL) THEN
    new$SummaYear2 := 0;
  END IF;
  IF (new$SummaYear3 IS NULL) THEN
    new$SummaYear3 := 0;
  END IF;
  IF (new$SummaYear4 IS NULL) THEN
    new$SummaYear4 := 0;
  END IF;
  IF (new$SummaOtherYears IS NULL) THEN
    new$SummaOtherYears := 0;
  END IF;
  IF (new$SummaYear2Delta IS NULL) THEN
    new$SummaYear2Delta := 0;
  END IF;
  IF (new$SummaYear3Delta IS NULL) THEN
    new$SummaYear3Delta := 0;
  END IF;
  IF (new$SummaYear4Delta IS NULL) THEN
    new$SummaYear4Delta := 0;
  END IF;
  IF (new$SummaOtherYearsDelta IS NULL) THEN
    new$SummaOtherYearsDelta := 0;
  END IF;
  /*   ,        */
  IF (new$ProgIndex = 304 AND new$RecordIndex IS NOT NULL) THEN
    SELECT COUNT(*) INTO CNT$1
    FROM AgreementSteps s WHERE (s.Id = new$RecordIndex AND s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    IF (NOT (CNT$1<> 0)) THEN
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*       */
  IF ((new$BudgetRef IS NULL) OR (new$BudgetRef = 0)) THEN
    IF (new$ProgIndex IN (304,314,317,318)) THEN
      BEGIN
        SELECT a.BudgetRef       INTO new$BudgetRef FROM Agreements a
        WHERE a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    ELSE
      IF (new$ProgIndex = 308) THEN
        BEGIN
          SELECT e.BudgetRef
          INTO new$BudgetRef       FROM ExecutionDocumentsCaption e
          WHERE e.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
  END IF;

  /*    ,     ,      */
  IF (new$AdjustmentRef IS NULL) THEN
    select g_shared.nextval into new$InnerPromiseNum from dual;
    new$ParentNumber := NULL;

  ELSE
    /*      , ..     */
    IF (new$Accepted = 0) THEN
      BEGIN
        SELECT
        InnerPromiseNum, ANumber
        INTO PreviousInner$, AdjDocNum$       FROM Paymentschedule
        WHERE ID = new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    ELSE
      BEGIN
        /*          */
        SELECT
        InnerPromiseNum, ANumber
        INTO PreviousInner$, AdjDocNum$       FROM Paymentschedule
        WHERE ID = new$AdjustmentRef AND LastAccepted = 1 AND LastAdjustment = 1
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      IF (PreviousInner$ IS NULL) THEN
        RaiseException('EX_NotFindInnerNumber');
      END IF;
    END IF;
    new$InnerPromiseNum := PreviousInner$;
    new$ParentNumber := AdjDocNum$;

  END IF;
  /*    ,    */
  IF ((new$BudgetRef IS NULL) OR (new$BudgetRef = 0))
  THEN
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  IF (new$ANumber IS NOT NULL) THEN
    SELECT COUNT(                    id
    ) INTO CNT$2
    FROM
    PaymentSchedule ps
    WHERE
    (                    (ps.ANumber = new$ANumber)
    AND
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    IF ((CNT$2<> 0)) THEN
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;

  /*    */
  IF ((new$SENDERRECORDID IS NULL) AND (new$SENDERID IS NULL)) THEN
    GETTARGETCLS(NULL, new$transfertcls, NULL, new$meanstype,
    new$targetcls,new$targetcls);
  END IF;
  /*   */
  GetDocumentKESR(NULL, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BI_1 (TR_PAYMENTSCHEDULE_BI_1)
-- Version 14.10.00.1
-- - - - - - - - - - - - -

  /*   1.0*/    
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  if (new$ProgIndex not in (317,318)) then
    new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_PAYMENTSCHEDULE_BI_10)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*   13.10.01*/

  /*    .*/
  if (new$InnerPromiseNum is null) then
    RaiseException('EX_BP_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from PaymentSchedule
  where (InnerPromiseNum = new$InnerPromiseNum)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;

  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;

  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is not null) then
    /*       */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is not null)
    ;
    /*     ,  */
    if (Tmp$ = 0) then
      RaiseException('EX_BP_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from PaymentSchedule
    where (InnerPromiseNum = new$InnerPromiseNum) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_BP_AdjustDuplicate');
    END IF;
    /*   - ,  ,       */
    if (new$ProgIndex in (304, 314)) then
      BEGIN
        /*     */
        select a.InnerNumber
        into InnerNumber_child$             from Agreements a
        where a.ID = new$AgreementRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN
        /*       */
        select a.InnerNumber
        into InnerNumber_parent$             from PaymentSchedule ps
        left join Agreements a on (a.Id = ps.AgreementRef)
        where (ps.Id = new$AdjustmentRef)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*      */
      if (InnerNumber_parent$ <> InnerNumber_child$) then
        RaiseException('EX_PROMISE_ADJ_INCORRECT');
      END IF;
    else
      if (new$ProgIndex = 308) then
        BEGIN
          /*     */
          select edc.InnerNumber
          into InnerNumber_child$             from ExecutionDocumentsCaption edc
          where edc.ID = new$ExecutionRef
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        BEGIN
          /*       */
          select edc.InnerNumber
          into InnerNumber_parent$             from PaymentSchedule ps
          left join ExecutionDocumentsCaption edc on (edc.id=ps.ExecutionRef)
          where (ps.Id = new$AdjustmentRef)
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        /*      */
        if (InnerNumber_parent$ <> InnerNumber_child$) then
          RaiseException('EX_PROMISE_ADJ_INCORRECT');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_PAYMENTSCHEDULE_BI_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$,
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;

  else    /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_PAYMENTSCHEDULE_BI_200)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*      */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_500 (TR_PAYMENTSCHEDULE_BI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_PAYMENTSCHEDULE (
    ID,
    ANUMBER,
    PARENTNUMBER,
    KFSR,
    KESR,
    KVSR,
    KCSR,
    KVR,
    MONTH01,
    MONTH02,
    MONTH03,
    MONTH04,
    MONTH05,
    MONTH06,
    MONTH07,
    MONTH08,
    MONTH09,
    MONTH10,
    MONTH11,
    MONTH12,
    SUMMA,
    REGION,
    SUBKESR,
    MEANSTYPE,
    FINSOURCE,
    FINTYPE,
    FACT,
    FACIALACC_CLS,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    ACCEPTDATE,
    LASTADJUSTMENT,
    ACCEPTED,
    LASTACCEPTED,
    PROMISETYPE,
    ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR,
    QUARTER1,
    QUARTER2,
    QUARTER3,
    QUARTER4,
    RECORDINDEX,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DIRECTIONCLS,
    RVERSION,
    BUHOPERATIONCLS,
    MONTH01DELTA,
    MONTH02DELTA,
    MONTH03DELTA,
    MONTH04DELTA,
    MONTH05DELTA,
    MONTH06DELTA,
    MONTH07DELTA,
    MONTH08DELTA,
    MONTH09DELTA,
    MONTH10DELTA,
    MONTH11DELTA,
    MONTH12DELTA,
    QUARTER1DELTA,
    QUARTER2DELTA,
    QUARTER3DELTA,
    QUARTER4DELTA,
    SUMMADELTA,
    NOTE,
    FINYEAR,
    SUMMAYEAR2,
    SUMMAYEAR3,
    SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA,
    ASSIGNMENTKIND,
    TRANSFERTCLS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXECUTIONREF,
    INNERPROMISENUM,
    ADJUSTMENTNUMBER,
    PROMISENUMBER,
    SUBSIDYCLS,
    AGREEMENTREF,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    PROGINDEX,
    INVESTOBJECT,
    SUMMAYEAR4,
    SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    OLDNUMBER,
    PAYMENTCODETYPE,
    REGPROJECTRESULT,
    PAYTARGETFUNDS,
    ANALYTICALPARTITION
  ) VALUES (
    new$ID,
    new$ANUMBER,
    new$PARENTNUMBER,
    new$KFSR,
    new$KESR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$MONTH01,
    new$MONTH02,
    new$MONTH03,
    new$MONTH04,
    new$MONTH05,
    new$MONTH06,
    new$MONTH07,
    new$MONTH08,
    new$MONTH09,
    new$MONTH10,
    new$MONTH11,
    new$MONTH12,
    new$SUMMA,
    new$REGION,
    new$SUBKESR,
    new$MEANSTYPE,
    new$FINSOURCE,
    new$FINTYPE,
    new$FACT,
    new$FACIALACC_CLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$ACCEPTDATE,
    new$LASTADJUSTMENT,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$PROMISETYPE,
    new$ADJUSTMENTREF,
    new$SUMMAPREVIOUSYEAR,
    new$SUMMAFINPREVIOUSYEAR,
    new$QUARTER1,
    new$QUARTER2,
    new$QUARTER3,
    new$QUARTER4,
    new$RECORDINDEX,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DIRECTIONCLS,
    new$RVERSION,
    new$BUHOPERATIONCLS,
    new$MONTH01DELTA,
    new$MONTH02DELTA,
    new$MONTH03DELTA,
    new$MONTH04DELTA,
    new$MONTH05DELTA,
    new$MONTH06DELTA,
    new$MONTH07DELTA,
    new$MONTH08DELTA,
    new$MONTH09DELTA,
    new$MONTH10DELTA,
    new$MONTH11DELTA,
    new$MONTH12DELTA,
    new$QUARTER1DELTA,
    new$QUARTER2DELTA,
    new$QUARTER3DELTA,
    new$QUARTER4DELTA,
    new$SUMMADELTA,
    new$NOTE,
    new$FINYEAR,
    new$SUMMAYEAR2,
    new$SUMMAYEAR3,
    new$SUMMAYEAR2DELTA,
    new$SUMMAYEAR3DELTA,
    new$ASSIGNMENTKIND,
    new$TRANSFERTCLS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXECUTIONREF,
    new$INNERPROMISENUM,
    new$ADJUSTMENTNUMBER,
    new$PROMISENUMBER,
    new$SUBSIDYCLS,
    new$AGREEMENTREF,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$PROGINDEX,
    new$INVESTOBJECT,
    new$SUMMAYEAR4,
    new$SUMMAOTHERYEARS,
    new$SUMMAYEAR4DELTA,
    new$SUMMAOTHERYEARSDELTA,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$OLDNUMBER,
    new$PAYMENTCODETYPE,
    new$REGPROJECTRESULT,
    new$PAYTARGETFUNDS,
    new$ANALYTICALPARTITION);

-- - - - - - - - - - - - -
-- AI_10 (TR_PAYMENTSCHEDULE_AI_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update PaymentSchedule set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_PAYMENTSCHEDULE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 113) and (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_PAYMENTSCHEDULE_BU_1
CREATE OR REPLACE TRIGGER TR_PAYMENTSCHEDULE_IU
  INSTEAD OF UPDATE
  ON PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  new$ID PAYMENTSCHEDULE.ID%TYPE := :NEW.ID;
  new$ANUMBER PAYMENTSCHEDULE.ANUMBER%TYPE := :NEW.ANUMBER;
  new$PARENTNUMBER PAYMENTSCHEDULE.PARENTNUMBER%TYPE := :NEW.PARENTNUMBER;
  new$KFSR PAYMENTSCHEDULE.KFSR%TYPE := :NEW.KFSR;
  new$KESR PAYMENTSCHEDULE.KESR%TYPE := :NEW.KESR;
  new$KVSR PAYMENTSCHEDULE.KVSR%TYPE := :NEW.KVSR;
  new$KCSR PAYMENTSCHEDULE.KCSR%TYPE := :NEW.KCSR;
  new$KVR PAYMENTSCHEDULE.KVR%TYPE := :NEW.KVR;
  new$MONTH01 PAYMENTSCHEDULE.MONTH01%TYPE := :NEW.MONTH01;
  new$MONTH02 PAYMENTSCHEDULE.MONTH02%TYPE := :NEW.MONTH02;
  new$MONTH03 PAYMENTSCHEDULE.MONTH03%TYPE := :NEW.MONTH03;
  new$MONTH04 PAYMENTSCHEDULE.MONTH04%TYPE := :NEW.MONTH04;
  new$MONTH05 PAYMENTSCHEDULE.MONTH05%TYPE := :NEW.MONTH05;
  new$MONTH06 PAYMENTSCHEDULE.MONTH06%TYPE := :NEW.MONTH06;
  new$MONTH07 PAYMENTSCHEDULE.MONTH07%TYPE := :NEW.MONTH07;
  new$MONTH08 PAYMENTSCHEDULE.MONTH08%TYPE := :NEW.MONTH08;
  new$MONTH09 PAYMENTSCHEDULE.MONTH09%TYPE := :NEW.MONTH09;
  new$MONTH10 PAYMENTSCHEDULE.MONTH10%TYPE := :NEW.MONTH10;
  new$MONTH11 PAYMENTSCHEDULE.MONTH11%TYPE := :NEW.MONTH11;
  new$MONTH12 PAYMENTSCHEDULE.MONTH12%TYPE := :NEW.MONTH12;
  new$SUMMA PAYMENTSCHEDULE.SUMMA%TYPE := :NEW.SUMMA;
  new$REGION PAYMENTSCHEDULE.REGION%TYPE := :NEW.REGION;
  new$SUBKESR PAYMENTSCHEDULE.SUBKESR%TYPE := :NEW.SUBKESR;
  new$MEANSTYPE PAYMENTSCHEDULE.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FINSOURCE PAYMENTSCHEDULE.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE PAYMENTSCHEDULE.FINTYPE%TYPE := :NEW.FINTYPE;
  new$FACT PAYMENTSCHEDULE.FACT%TYPE := :NEW.FACT;
  new$FACIALACC_CLS PAYMENTSCHEDULE.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$CREATERUSER PAYMENTSCHEDULE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE PAYMENTSCHEDULE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE PAYMENTSCHEDULE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER PAYMENTSCHEDULE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF PAYMENTSCHEDULE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$ACCEPTDATE PAYMENTSCHEDULE.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$LASTADJUSTMENT PAYMENTSCHEDULE.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$ACCEPTED PAYMENTSCHEDULE.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED PAYMENTSCHEDULE.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$PROMISETYPE PAYMENTSCHEDULE.PROMISETYPE%TYPE := :NEW.PROMISETYPE;
  new$ADJUSTMENTREF PAYMENTSCHEDULE.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$SUMMAPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAPREVIOUSYEAR%TYPE := :NEW.SUMMAPREVIOUSYEAR;
  new$SUMMAFINPREVIOUSYEAR PAYMENTSCHEDULE.SUMMAFINPREVIOUSYEAR%TYPE := :NEW.SUMMAFINPREVIOUSYEAR;
  new$QUARTER1 PAYMENTSCHEDULE.QUARTER1%TYPE := :NEW.QUARTER1;
  new$QUARTER2 PAYMENTSCHEDULE.QUARTER2%TYPE := :NEW.QUARTER2;
  new$QUARTER3 PAYMENTSCHEDULE.QUARTER3%TYPE := :NEW.QUARTER3;
  new$QUARTER4 PAYMENTSCHEDULE.QUARTER4%TYPE := :NEW.QUARTER4;
  new$RECORDINDEX PAYMENTSCHEDULE.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CRYPTOSTATUS PAYMENTSCHEDULE.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID PAYMENTSCHEDULE.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID PAYMENTSCHEDULE.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DIRECTIONCLS PAYMENTSCHEDULE.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$RVERSION PAYMENTSCHEDULE.RVERSION%TYPE := :NEW.RVERSION;
  new$BUHOPERATIONCLS PAYMENTSCHEDULE.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$MONTH01DELTA PAYMENTSCHEDULE.MONTH01DELTA%TYPE := :NEW.MONTH01DELTA;
  new$MONTH02DELTA PAYMENTSCHEDULE.MONTH02DELTA%TYPE := :NEW.MONTH02DELTA;
  new$MONTH03DELTA PAYMENTSCHEDULE.MONTH03DELTA%TYPE := :NEW.MONTH03DELTA;
  new$MONTH04DELTA PAYMENTSCHEDULE.MONTH04DELTA%TYPE := :NEW.MONTH04DELTA;
  new$MONTH05DELTA PAYMENTSCHEDULE.MONTH05DELTA%TYPE := :NEW.MONTH05DELTA;
  new$MONTH06DELTA PAYMENTSCHEDULE.MONTH06DELTA%TYPE := :NEW.MONTH06DELTA;
  new$MONTH07DELTA PAYMENTSCHEDULE.MONTH07DELTA%TYPE := :NEW.MONTH07DELTA;
  new$MONTH08DELTA PAYMENTSCHEDULE.MONTH08DELTA%TYPE := :NEW.MONTH08DELTA;
  new$MONTH09DELTA PAYMENTSCHEDULE.MONTH09DELTA%TYPE := :NEW.MONTH09DELTA;
  new$MONTH10DELTA PAYMENTSCHEDULE.MONTH10DELTA%TYPE := :NEW.MONTH10DELTA;
  new$MONTH11DELTA PAYMENTSCHEDULE.MONTH11DELTA%TYPE := :NEW.MONTH11DELTA;
  new$MONTH12DELTA PAYMENTSCHEDULE.MONTH12DELTA%TYPE := :NEW.MONTH12DELTA;
  new$QUARTER1DELTA PAYMENTSCHEDULE.QUARTER1DELTA%TYPE := :NEW.QUARTER1DELTA;
  new$QUARTER2DELTA PAYMENTSCHEDULE.QUARTER2DELTA%TYPE := :NEW.QUARTER2DELTA;
  new$QUARTER3DELTA PAYMENTSCHEDULE.QUARTER3DELTA%TYPE := :NEW.QUARTER3DELTA;
  new$QUARTER4DELTA PAYMENTSCHEDULE.QUARTER4DELTA%TYPE := :NEW.QUARTER4DELTA;
  new$SUMMADELTA PAYMENTSCHEDULE.SUMMADELTA%TYPE := :NEW.SUMMADELTA;
  new$NOTE PAYMENTSCHEDULE.NOTE%TYPE := :NEW.NOTE;
  new$FINYEAR PAYMENTSCHEDULE.FINYEAR%TYPE := :NEW.FINYEAR;
  new$SUMMAYEAR2 PAYMENTSCHEDULE.SUMMAYEAR2%TYPE := :NEW.SUMMAYEAR2;
  new$SUMMAYEAR3 PAYMENTSCHEDULE.SUMMAYEAR3%TYPE := :NEW.SUMMAYEAR3;
  new$SUMMAYEAR2DELTA PAYMENTSCHEDULE.SUMMAYEAR2DELTA%TYPE := :NEW.SUMMAYEAR2DELTA;
  new$SUMMAYEAR3DELTA PAYMENTSCHEDULE.SUMMAYEAR3DELTA%TYPE := :NEW.SUMMAYEAR3DELTA;
  new$ASSIGNMENTKIND PAYMENTSCHEDULE.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TRANSFERTCLS PAYMENTSCHEDULE.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$SENDERIDKEY PAYMENTSCHEDULE.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY PAYMENTSCHEDULE.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXECUTIONREF PAYMENTSCHEDULE.EXECUTIONREF%TYPE := :NEW.EXECUTIONREF;
  new$INNERPROMISENUM PAYMENTSCHEDULE.INNERPROMISENUM%TYPE := :NEW.INNERPROMISENUM;
  new$ADJUSTMENTNUMBER PAYMENTSCHEDULE.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$PROMISENUMBER PAYMENTSCHEDULE.PROMISENUMBER%TYPE := :NEW.PROMISENUMBER;
  new$SUBSIDYCLS PAYMENTSCHEDULE.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$AGREEMENTREF PAYMENTSCHEDULE.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$BUDALLOCATIONCLS PAYMENTSCHEDULE.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS PAYMENTSCHEDULE.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$PROGINDEX PAYMENTSCHEDULE.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$INVESTOBJECT PAYMENTSCHEDULE.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$SUMMAYEAR4 PAYMENTSCHEDULE.SUMMAYEAR4%TYPE := :NEW.SUMMAYEAR4;
  new$SUMMAOTHERYEARS PAYMENTSCHEDULE.SUMMAOTHERYEARS%TYPE := :NEW.SUMMAOTHERYEARS;
  new$SUMMAYEAR4DELTA PAYMENTSCHEDULE.SUMMAYEAR4DELTA%TYPE := :NEW.SUMMAYEAR4DELTA;
  new$SUMMAOTHERYEARSDELTA PAYMENTSCHEDULE.SUMMAOTHERYEARSDELTA%TYPE := :NEW.SUMMAOTHERYEARSDELTA;
  new$CONTRACTCOSTSCLS PAYMENTSCHEDULE.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS PAYMENTSCHEDULE.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$OLDNUMBER PAYMENTSCHEDULE.OLDNUMBER%TYPE := :NEW.OLDNUMBER;
  new$PAYMENTCODETYPE PAYMENTSCHEDULE.PAYMENTCODETYPE%TYPE := :NEW.PAYMENTCODETYPE;
  new$REGPROJECTRESULT PAYMENTSCHEDULE.REGPROJECTRESULT%TYPE := :NEW.REGPROJECTRESULT;
  new$PAYTARGETFUNDS PAYMENTSCHEDULE.PAYTARGETFUNDS%TYPE := :NEW.PAYTARGETFUNDS;
  new$ANALYTICALPARTITION PAYMENTSCHEDULE.ANALYTICALPARTITION%TYPE := :NEW.ANALYTICALPARTITION;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  previousAccept$ NUMBER(10);
  previousAcceptDate$ NUMBER(10);
  M011$ NUMBER;
  M021$ NUMBER;
  M031$ NUMBER;
  M041$ NUMBER;
  M051$ NUMBER;
  M061$ NUMBER;
  M071$ NUMBER;
  M081$ NUMBER;
  M091$ NUMBER;
  M101$ NUMBER;
  M111$ NUMBER;
  M121$ NUMBER;
  Q11$ NUMBER;
  Q21$ NUMBER;
  Q31$ NUMBER;
  Q41$ NUMBER;
  S5$ NUMBER;
  S21$ NUMBER;
  S31$ NUMBER;
  S41$ NUMBER;
  SOther1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_PAYMENTSCHEDULE_BU)
-- Version 14.00.00.2
-- - - - - - - - - - - - -

  /*   2.4*/
  /*    -*/
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  if (new$PromiseType is null) then
    new$PromiseType := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$AssignmentKind is null) then
    new$AssignmentKind := 0;
  END IF;

  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;

  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$FinSource is null) then
    new$FinSource := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$BuhOperationCLS is null) then
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  if (new$Month01 is null) then
    new$Month01 := 0;
  END IF;
  if (new$Month02 is null) then
    new$Month02 := 0;
  END IF;
  if (new$Month03 is null) then
    new$Month03 := 0;
  END IF;
  if (new$Month04 is null) then
    new$Month04 := 0;
  END IF;
  if (new$Month05 is null) then
    new$Month05 := 0;
  END IF;
  if (new$Month06 is null) then
    new$Month06 := 0;
  END IF;
  if (new$Month07 is null) then
    new$Month07 := 0;
  END IF;
  if (new$Month08 is null) then
    new$Month08 := 0;
  END IF;
  if (new$Month09 is null) then
    new$Month09 := 0;
  END IF;
  if (new$Month10 is null) then
    new$Month10 := 0;
  END IF;
  if (new$Month11 is null) then
    new$Month11 := 0;
  END IF;
  if (new$Month12 is null) then
    new$Month12 := 0;
  END IF;
  if (new$Quarter1 is null) then
    new$Quarter1 := 0;
  END IF;
  if (new$Quarter2 is null) then
    new$Quarter2 := 0;
  END IF;
  if (new$Quarter3 is null) then
    new$Quarter3 := 0;
  END IF;
  if (new$Quarter4 is null) then
    new$Quarter4 := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$Month01Delta is null) then
    new$Month01Delta := 0;
  END IF;
  if (new$Month02Delta is null) then
    new$Month02Delta := 0;
  END IF;
  if (new$Month03Delta is null) then
    new$Month03Delta := 0;
  END IF;
  if (new$Month04Delta is null) then
    new$Month04Delta := 0;
  END IF;
  if (new$Month05Delta is null) then
    new$Month05Delta := 0;
  END IF;
  if (new$Month06Delta is null) then
    new$Month06Delta := 0;
  END IF;
  if (new$Month07Delta is null) then
    new$Month07Delta := 0;
  END IF;
  if (new$Month08Delta is null) then
    new$Month08Delta := 0;
  END IF;
  if (new$Month09Delta is null) then
    new$Month09Delta := 0;
  END IF;
  if (new$Month10Delta is null) then
    new$Month10Delta := 0;
  END IF;
  if (new$Month11Delta is null) then
    new$Month11Delta := 0;
  END IF;
  if (new$Month12Delta is null) then
    new$Month12Delta := 0;
  END IF;
  if (new$Quarter1Delta is null) then
    new$Quarter1Delta := 0;
  END IF;
  if (new$Quarter2Delta is null) then
    new$Quarter2Delta := 0;
  END IF;
  if (new$Quarter3Delta is null) then
    new$Quarter3Delta := 0;
  END IF;
  if (new$Quarter4Delta is null) then
    new$Quarter4Delta := 0;
  END IF;
  if (new$SummaDelta is null) then
    new$SummaDelta := 0;
  END IF;
  if (new$SummaPreviousYear is null) then
    new$SummaPreviousYear := 0;
  END IF;
  if (new$SummaFinPreviousYear is null) then
    new$SummaFinPreviousYear := 0;
  END IF;

  if (new$SummaYear2 is null) then
    new$SummaYear2 := 0;
  END IF;
  if (new$SummaYear3 is null) then
    new$SummaYear3 := 0;
  END IF;
  if (new$SummaYear4 is null) then
    new$SummaYear4 := 0;
  END IF;
  if (new$SummaOtherYears is null) then
    new$SummaOtherYears := 0;
  END IF;

  if (new$SummaYear2Delta is null) then
    new$SummaYear2Delta := 0;
  END IF;
  if (new$SummaYear3Delta is null) then
    new$SummaYear3Delta := 0;
  END IF;
  if (new$SummaYear4Delta is null) then
    new$SummaYear4Delta := 0;
  END IF;
  if (new$SummaOtherYearsDelta is null) then
    new$SummaOtherYearsDelta := 0;
  END IF;

  /*   ,        */
  if (new$ProgIndex = 304 and new$RecordIndex is not null and (:old.RecordIndex is null or :old.RecordIndex <> new$RecordIndex)) then
    SELECT COUNT(*) INTO CNT$1
    from AgreementSteps s where (s.Id = new$RecordIndex and s.RecordIndex = new$AgreementRef) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('Ex_WrongStep');
    END IF;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      RaiseException('Ex_CantModufyBudget');
    END IF;
  END IF;
  if ((:old.ANumber is null) and (new$ANumber is not Null)) then
    SELECT COUNT(                    id
    ) INTO CNT$2
    from
    PaymentSchedule ps
    where
    (                    (ps.ANumber = new$ANumber)
    and
    (ps.BudgetRef = new$BudgetRef)) AND (ROWNUM = 1);
    if ((CNT$2<> 0)) then
      RaiseException('ex_Promise_NumUQ');
    END IF;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls);
  /*   */
  GetDocumentKESR(:old.SubKESR, new$SubKESR, new$KESR, new$BudgetRef,new$KESR);

-- - - - - - - - - - - - -
-- BU_1 (TR_PAYMENTSCHEDULE_BU_1)
-- Version 14.10.00.1
-- - - - - - - - - - - - -

  /*   1.0*/    
  new$Quarter1 := new$Month01 + new$Month02 + new$Month03;
  new$Quarter2 := new$Month04 + new$Month05 + new$Month06;
  new$Quarter3 := new$Month07 + new$Month08 + new$Month09;
  new$Quarter4 := new$Month10 + new$Month11 + new$Month12;
  if (new$ProgIndex not in (317,318)) then
    new$Summa := new$Quarter1 + new$Quarter2 + new$Quarter3 + new$Quarter4;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_PAYMENTSCHEDULE_BU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /* ,      ,   */
  if ((new$ANumber <> :old.ANumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$InnerPromiseNum <> :old.InnerPromiseNum) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;

  /*   */
  if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
  ((new$Accepted = 1) or (new$AcceptDate is null))) then
    BEGIN
      /*             */
      select Accepted, AcceptDate
      into previousAccept$, previousAcceptDate$       from Paymentschedule
      where id=new$Adjustmentref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$Adjustmentref is not null and (previousAccept$ = 0 or previousAcceptDate$ is null)) then
      RaiseException('EX_RollbackCancel');
    END IF;
    new$LastAdjustment := 1;

  END IF;
  /*   ,     LastAccepted*/
  if ((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_BP_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_BP_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (TR_PAYMENTSCHEDULE_BU_100)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*           */
  if (new$AdjustmentNumber > 0) then
    BEGIN
      select
      Month01, Month02, Month03, Month04, Month05, Month06,
      Month07, Month08, Month09, Month10, Month11, Month12,
      Quarter1, Quarter2, Quarter3, Quarter4, Summa,
      SummaYear2, SummaYear3, SummaYear4, SummaOtherYears
      into
      M011$, M021$, M031$, M041$, M051$, M061$, M071$, M081$, M091$, M101$, M111$, M121$,
      Q11$, Q21$, Q31$, Q41$, S5$, S21$, S31$, S41$, SOther1$         from
      PaymentSchedule
      where
      ID = new$AdjustmentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;

    new$Month01Delta := new$Month01 - M011$;
    new$Month02Delta := new$Month02 - M021$;
    new$Month03Delta := new$Month03 - M031$;
    new$Month04Delta := new$Month04 - M041$;
    new$Month05Delta := new$Month05 - M051$;
    new$Month06Delta := new$Month06 - M061$;
    new$Month07Delta := new$Month07 - M071$;
    new$Month08Delta := new$Month08 - M081$;
    new$Month09Delta := new$Month09 - M091$;
    new$Month10Delta := new$Month10 - M101$;
    new$Month11Delta := new$Month11 - M111$;
    new$Month12Delta := new$Month12 - M121$;
    new$Quarter1Delta := new$Quarter1 - Q11$;
    new$Quarter2Delta := new$Quarter2 - Q21$;
    new$Quarter3Delta := new$Quarter3 - Q31$;
    new$Quarter4Delta := new$Quarter4 - Q41$;
    new$SummaDelta := new$Summa - S5$;
    new$SummaYear2Delta := new$SummaYear2 - S21$;
    new$SummaYear3Delta := new$SummaYear3 - S31$;
    new$SummaYear4Delta := new$SummaYear4 - S41$;
    new$SummaOtherYearsDelta := new$SummaOtherYears - SOther1$;

  else /*        */
    new$Month01Delta := new$Month01;
    new$Month02Delta := new$Month02;
    new$Month03Delta := new$Month03;
    new$Month04Delta := new$Month04;
    new$Month05Delta := new$Month05;
    new$Month06Delta := new$Month06;
    new$Month07Delta := new$Month07;
    new$Month08Delta := new$Month08;
    new$Month09Delta := new$Month09;
    new$Month10Delta := new$Month10;
    new$Month11Delta := new$Month11;
    new$Month12Delta := new$Month12;
    new$Quarter1Delta := new$Quarter1;
    new$Quarter2Delta := new$Quarter2;
    new$Quarter3Delta := new$Quarter3;
    new$Quarter4Delta := new$Quarter4;
    new$SummaDelta := new$Summa;
    new$SummaYear2Delta := new$SummaYear2;
    new$SummaYear3Delta := new$SummaYear3;
    new$SummaYear4Delta := new$SummaYear4;
    new$SummaOtherYearsDelta := new$SummaOtherYears;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_PAYMENTSCHEDULE_BU_200)
-- Version 14.00.00.1
-- - - - - - - - - - - - -

  /*    */
  if (new$Accepted = 0 and new$AcceptDate is not null and :old.Accepted = 1) then
    /*   ,     
         *    ,      */
    FOR REC$1 IN (      select ffc.Reject_Cls  AS DocumentRejectCls from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum
    )
    LOOP
      if (REC$1.DocumentRejectCls is null) then
        RaiseException('Ex_BP_CannotReject');
      END IF;
    END LOOP;
    /* ,         */
    FOR REC$1 IN (      SELECT Count(ps_in.ID)  AS AdjCount FROM PaymentSchedule ps_in
    WHERE (ps_in.InnerPromiseNum = new$InnerPromiseNum)and(ps_in.AdjustmentNumber > new$AdjustmentNumber)
    and (ps_in.Accepted<>0)
    )
    LOOP
      if (REC$1.AdjCount > 0) then
        RaiseException('EX_BP_AdjustmentedCANNOTREJECT');
      END IF;
    END LOOP;
  END IF;
  /*   .       */
  if (new$Accepted = 1 and new$AcceptDate is null and :old.Accepted = 1 and :old.AcceptDate is not null) then
    SELECT COUNT(ffc.id ) INTO CNT$1
    from FacialFinDetail ffd
    left join FacialFinCaption ffc on (ffc.ID = ffd.RecordIndex)
    where ((SourcePromise = new$ANumber and SourceBudgetPromise = new$InnerPromiseNum
    or DestPromise = new$ANumber and DestBudgetPromise = new$InnerPromiseNum)
    and ffc.acceptdate is not null and ffc.Reject_cls is null) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_BP_NOTACCEPTED');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_PaymentSchedule_BU_400)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$AgreementRef <> :old.AgreementRef or new$ExecutionRef <> :old.ExecutionRef) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_PAYMENTSCHEDULE_BU_700)
-- Create 14.10.2004
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$RVersion is null) then
    new$RVersion := 1;
  elsif ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
    new$RVersion := :Old.RVersion;
  else
    new$RVersion := :Old.RVersion + 1;
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_PAYMENTSCHEDULE SET
    ID = new$ID,
    ANUMBER = new$ANUMBER,
    PARENTNUMBER = new$PARENTNUMBER,
    KFSR = new$KFSR,
    KESR = new$KESR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    MONTH01 = new$MONTH01,
    MONTH02 = new$MONTH02,
    MONTH03 = new$MONTH03,
    MONTH04 = new$MONTH04,
    MONTH05 = new$MONTH05,
    MONTH06 = new$MONTH06,
    MONTH07 = new$MONTH07,
    MONTH08 = new$MONTH08,
    MONTH09 = new$MONTH09,
    MONTH10 = new$MONTH10,
    MONTH11 = new$MONTH11,
    MONTH12 = new$MONTH12,
    SUMMA = new$SUMMA,
    REGION = new$REGION,
    SUBKESR = new$SUBKESR,
    MEANSTYPE = new$MEANSTYPE,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    FACT = new$FACT,
    FACIALACC_CLS = new$FACIALACC_CLS,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    ACCEPTDATE = new$ACCEPTDATE,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    PROMISETYPE = new$PROMISETYPE,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    SUMMAPREVIOUSYEAR = new$SUMMAPREVIOUSYEAR,
    SUMMAFINPREVIOUSYEAR = new$SUMMAFINPREVIOUSYEAR,
    QUARTER1 = new$QUARTER1,
    QUARTER2 = new$QUARTER2,
    QUARTER3 = new$QUARTER3,
    QUARTER4 = new$QUARTER4,
    RECORDINDEX = new$RECORDINDEX,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DIRECTIONCLS = new$DIRECTIONCLS,
    RVERSION = new$RVERSION,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    MONTH01DELTA = new$MONTH01DELTA,
    MONTH02DELTA = new$MONTH02DELTA,
    MONTH03DELTA = new$MONTH03DELTA,
    MONTH04DELTA = new$MONTH04DELTA,
    MONTH05DELTA = new$MONTH05DELTA,
    MONTH06DELTA = new$MONTH06DELTA,
    MONTH07DELTA = new$MONTH07DELTA,
    MONTH08DELTA = new$MONTH08DELTA,
    MONTH09DELTA = new$MONTH09DELTA,
    MONTH10DELTA = new$MONTH10DELTA,
    MONTH11DELTA = new$MONTH11DELTA,
    MONTH12DELTA = new$MONTH12DELTA,
    QUARTER1DELTA = new$QUARTER1DELTA,
    QUARTER2DELTA = new$QUARTER2DELTA,
    QUARTER3DELTA = new$QUARTER3DELTA,
    QUARTER4DELTA = new$QUARTER4DELTA,
    SUMMADELTA = new$SUMMADELTA,
    NOTE = new$NOTE,
    FINYEAR = new$FINYEAR,
    SUMMAYEAR2 = new$SUMMAYEAR2,
    SUMMAYEAR3 = new$SUMMAYEAR3,
    SUMMAYEAR2DELTA = new$SUMMAYEAR2DELTA,
    SUMMAYEAR3DELTA = new$SUMMAYEAR3DELTA,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TRANSFERTCLS = new$TRANSFERTCLS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXECUTIONREF = new$EXECUTIONREF,
    INNERPROMISENUM = new$INNERPROMISENUM,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    PROMISENUMBER = new$PROMISENUMBER,
    SUBSIDYCLS = new$SUBSIDYCLS,
    AGREEMENTREF = new$AGREEMENTREF,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    PROGINDEX = new$PROGINDEX,
    INVESTOBJECT = new$INVESTOBJECT,
    SUMMAYEAR4 = new$SUMMAYEAR4,
    SUMMAOTHERYEARS = new$SUMMAOTHERYEARS,
    SUMMAYEAR4DELTA = new$SUMMAYEAR4DELTA,
    SUMMAOTHERYEARSDELTA = new$SUMMAOTHERYEARSDELTA,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    OLDNUMBER = new$OLDNUMBER,
    PAYMENTCODETYPE = new$PAYMENTCODETYPE,
    REGPROJECTRESULT = new$REGPROJECTRESULT,
    PAYTARGETFUNDS = new$PAYTARGETFUNDS,
    ANALYTICALPARTITION = new$ANALYTICALPARTITION
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_10 (TR_PAYMENTSCHEDULE_AU_10)
-- Version 13.10.00.1
-- - - - - - - - - - - - -

  /*   13.10*/
  /*      */
  /*        */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update PaymentSchedule set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*              */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and ((:old.LastAdjustment = 1) or (new$LastAdjustment = 1))) then
    update PaymentSchedule set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update PaymentSchedule set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_PAYMENTSCHEDULE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (113, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=113) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
